'''
nose unit tests for CFchecker.cf12
'''
import os

from CFchecker.cf12 import CF12Tests
import cf11_test
import helpers

class CF12Tests_test(cf11_test.CF11Tests_test):
    '''
    nothing changed in checker code, so run same tests as for 1.0

    the input test data only has to be enhanced a bit to check if the new
    grid mappings are also recognized and then adapt test 5.6 to the
    new log messages
    '''
    test_class = CF12Tests

    @classmethod
    def setup_class(cls):
        cf11_test.CF11Tests_test.setup_class()
        helpers.amend_faulty_ncfile_cf12(os.path.join(cls.tempdir, cls.faulty_file))
        helpers.amend_good_ncfile_cf12(os.path.join(cls.tempdir, cls.good_file))

    def test_5_6_check(self):
        '''CF12Tests: test 5.6'''
        msgs = { self.faulty_file: [('ERROR', '5.6', '_spam_data: grid_mapping attribute has to be of type string'),
                                       ('ERROR', '5.6', 'casetest: value of grid_mapping attribute must be a single '
                                                 'variable name present in this file'),
                                       ('ERROR', '5.6', 'grid_mapping_3: grid_mapping_name "unknown_grid_mapping_name" '
                                                 'is unknown'),
                                       ('WARNING', '5.6', 'grid_mapping_1: a grid mapping variable should have 0 '
                                                   'dimensions'),
                                       ('ERROR', '5.6', 'grid_mapping_1: a grid mapping variable must have a '
                                                 'grid_mapping_name attribute'),
                                       ('ERROR', '5.6', 'grid_mapping_2: grid_mapping_name attribute has to be of type '
                                                 'string'),
                                       ('ERROR', '5.6', 'grid_mapping_4: the following attributes are not allowed for the '
                                                        'given grid_mapping_name (latitude_longitude): latitude_of_projection_origin,'
                                                        'scale_factor_at_central_meridian,grid_north_pole_temp,grid_north_pole_level'),
                                       ('ERROR', '5.6', 'grid_mapping_4: grid_mapping attribute longitude_of_prime_meridian\'s value '
                                                        'is out of bounds'),
                                       ],
                 self.good_file: [],
                }
        self.check_runner(msgs)
